<?php

use Carbon\Carbon;

add_hook('DailyCronJob', 1, function ($vars) {
    $adminUser = '';//管理员用户名
    $orderOverdueDays = 1;//允许订单逾期时间
    $invoiceOverdueDays = 3;//允许账单逾期时间

    $now = Carbon::now();
    $now->hour = 0;
    $now->minute = 0;
    $now->second = 0;

    //Accept order start
    $command = 'GetOrders';
    $postData = [
        'limitnum' => 10000,
        'status' => 'Pending'
    ];
    $results = localAPI($command, $postData, $adminUser);
    if (isset($results['orders']['order'])) {
        foreach ($results['orders']['order'] as $order) {
            if ($order['paymentstatus'] === 'Paid' || $order['amount'] === '0.00') {
                $command = 'AcceptOrder';
                $postData = [
                    'orderid' => $order['id']
                ];
                $results = localAPI($command, $postData, $adminUser);
                if ($results['result'] !== 'success') {
                    $postData = array(
                        'description' => 'Accept order failed #' . $order['id'],
                    );
                    $command = 'LogActivity';
                    localAPI($command, $postData, $adminUser);
                }
            }
        }
    }

    //Accept order end

    //Cancel order start
    $command = 'GetOrders';
    $postData = [
        'limitnum' => 10000,
        'status' => 'Pending'
    ];
    $results = localAPI($command, $postData, $adminUser);
    if (isset($results['orders']['order'])) {
        foreach ($results['orders']['order'] as $order) {
            $createDate = Carbon::parse($order['date']);
            $createDate->hour = 0;
            $createDate->minute = 0;
            $createDate->second = 0;
            if ($now->diffInDays($createDate) >= $orderOverdueDays) {
                $command = 'CancelOrder';
                $postData = [
                    'orderid' => $order['id']
                ];
                $results = localAPI($command, $postData, $adminUser);
                if ($results['result'] !== 'success') {
                    $postData = array(
                        'description' => 'Cancel order failed #' . $order['id'],
                    );
                    $command = 'LogActivity';
                    localAPI($command, $postData, $adminUser);
                }
            }
        }
    }
    //Cancel order end


    //Cancel invoices start
    $command = 'GetInvoices';
    $postData = [
        'limitnum' => 10000,
        'status' => 'Overdue'
    ];
    $results = localAPI($command, $postData, $adminUser);
    if (isset($results['invoices']['invoice'])) {
        foreach ($results['invoices']['invoice'] as $invoice) {
            $dueDate = Carbon::parse($invoice['duedate']);
            $dueDate->hour = 0;
            $dueDate->minute = 0;
            $dueDate->second = 0;
            if ($now->diffInDays($dueDate) >= $invoiceOverdueDays) {
                $command = 'UpdateInvoice';
                $postData = [
                    'invoiceid' => $invoice['id'],
                    'status' => 'Cancelled'
                ];
                $results = localAPI($command, $postData, $adminUser);
                if ($results['result'] === 'success') {
                    $postData = array(
                        'description' => 'Cancel invoice succeed #' . $invoice['id'],
                    );
                } else {
                    $postData = array(
                        'description' => 'Cancel invoice failed #' . $invoice['id'] . ';' . $results['message'],
                    );
                }
                $command = 'LogActivity';
                localAPI($command, $postData, $adminUser);
            }
        }
    }
    //Cancel invoices end
});